#ifndef _DX2MEMMAP_H_INCLUDE
#define _DX2MEMMAP_H_INCLUDE

#ifdef __cplusplus
extern "C" {
#endif

#define ADDRESS_PRO_MODEL_NUMBER          0   //W
#define ADDRESS_PRO_MODEL_INFORMATION     4   //L
#define ADDRESS_PRO_VERSION_FW            6   //B
#define ADDRESS_PRO_ID                    7   //B
#define ADDRESS_PRO_BAUDRATE              8   //B
#define ADDRESS_PRO_RETURN_DELAY_TIME     9   //B
#define ADDRESS_PRO_OPERATION_MODE        11  //B
#define ADDRESS_PRO_MOVING_THRESHOLD      17  //L
#define ADDRESS_PRO_TEMP_LIMIT            21  //B
#define ADDRESS_PRO_MAX_VOLTAGE_LIMIT     22  //W
#define ADDRESS_PRO_MIN_VOLTAGE_LIMIT     24  //W
#define ADDRESS_PRO_ACCELERATION_LIMIT    26  //L
#define ADDRESS_PRO_TORQUE_LIMIT          30  //W
#define ADDRESS_PRO_VELOCITY_LIMIT        32  //L
#define ADDRESS_PRO_MAX_POSITION_LIMIT    36  //L
#define ADDRESS_PRO_MIN_POSITION_LIMIT    40  //L
#define ADDRESS_PRO_SHUTDOWN              48  //B
#define ADDRESS_PRO_TORQUE_ENABLE         562 //B
#define ADDRESS_PRO_LED_RED               563 //B
#define ADDRESS_PRO_LED_GREEN             564 //B
#define ADDRESS_PRO_LED_BLUE              565 //B

#define ADDRESS_PRO_VELOCITY_I_GAIN       586 //W
#define ADDRESS_PRO_VELOCITY_P_GAIN       588 //W
#define ADDRESS_PRO_POSITION_P_GAIN       594 //W

#define ADDRESS_PRO_GOAL_POSITION         596 //L
#define ADDRESS_PRO_GOAL_VELOCITY         600 //L
#define ADDRESS_PRO_GOAL_TORQUE           604 //W
#define ADDRESS_PRO_GOAL_ACCELERATION     606 //L

#define ADDRESS_PRO_MOVING                610 //B
#define ADDRESS_PRO_PRESENT_POSITION      611 //L
#define ADDRESS_PRO_PRESENT_VELOCITY      615 //L
#define ADDRESS_PRO_PRESENT_CURRENT       621 //W
#define ADDRESS_PRO_PRESENT_VOLTAGE       623 //W
#define ADDRESS_PRO_PRESENT_TEMP          625 //B

#define ADDRESS_PRO_STATUS_RETURN_LEVEL   891 //B
#define ADDRESS_PRO_HARDWARE_ERROR_STATUS 892 //B




#define ADDRESS_XM_MODEL_NUMBER           0   //W
#define ADDRESS_XM_MODEL_INFORMATION      4   //L
#define ADDRESS_XM_VERSION_FW             6   //B
#define ADDRESS_XM_ID                     7   //B
#define ADDRESS_XM_BAUDRATE               8   //B
#define ADDRESS_XM_RETURN_DELAY_TIME      9   //B
#define ADDRESS_XM_OPERATION_MODE         11  //B
#define ADDRESS_XM_MAX_POSITION_LIMIT     48  //L
#define ADDRESS_XM_MIN_POSITION_LIMIT     52  //L

#define ADDRESS_XM_TORQUE_ENABLE          64  //B
#define ADDRESS_XM_LED_RED                65  //B

#define ADDRESS_XM_STATUS_RETURN_LEVEL    69  //B
#define ADDRESS_XM_HARDWARE_ERROR_STATUS  70  //B

#define ADDRESS_XM_VELOCITY_IGAIN         76  //W
#define ADDRESS_XM_VELOCITY_PGAIN         78  //W
#define ADDRESS_XM_VELOCITY_DGAIN         80  //W
#define ADDRESS_XM_POSITION_IGAIN         82  //W
#define ADDRESS_XM_POSITION_PGAIN         84  //W
#define ADDRESS_XM_GOAL_PWM               100 //W
#define ADDRESS_XM_GOAL_CURRENT           102 //W
#define ADDRESS_XM_GOAL_VELOCITY          104 //L
#define ADDRESS_XM_PROF_ACCELERATION      108 //L
#define ADDRESS_XM_PROF_VELOCITY          112 //L
#define ADDRESS_XM_GOAL_POSITION          116 //L
#define ADDRESS_XM_MOVING                 122 //B
#define ADDRESS_XM_MOVING_STATUS          123 //B
#define ADDRESS_XM_PRESENT_PWM            124 //W
#define ADDRESS_XM_PRESENT_CURRENT        126 //W
#define ADDRESS_XM_PRESENT_VELOCITY       128 //L
#define ADDRESS_XM_PRESENT_POSITION       132 //L
#define ADDRESS_XM_VELOCITY_TRAJECTORY    136 //L
#define ADDRESS_XM_POSITION_TRAJECTORY    140 //L
#define ADDRESS_XM_PRESENT_VOLTAGE        144 //W
#define ADDRESS_XM_PRESENT_TEMP           146 //B

#ifdef __cplusplus
}
#endif

#endif //_DX2MEMMAP_H_INCLUDE
